/* 
 * Method for clustering text data, SKWIC algorithm implementation
 * View class generating the Algorithm window
 * Vytvoril: Roman Milos, Vladimir Bartik, May 2011
 */


package dip.pohled;

import dip.Main;
import dip.kontroler.Gui;
import dip.model.IO;
import dip.model.Slovo;
import dip.model.algoritmus.DokumentShluku;
import dip.model.algoritmus.Shluk;
import dip.pohled.filtry.CSVFiltr;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;

/**
 * View class generating the Algorithm window
 * @author Roman
 */
public class AlgoritmusOkno extends javax.swing.JFrame {

    private JFrame frame;
    private final Gui gui;
    private Shluk vybranyShluk = null;
    private DokumentShluku vybranyDokumentShluku;

    public Shluk getVybranyShluk() {
        return vybranyShluk;
    }

    public void setVybranyShluk(Shluk vybranyShluk) {
        this.vybranyShluk = vybranyShluk;
    }

    /** Creates new form AlgoritmusOkno */
    public AlgoritmusOkno(Gui gui) {
        this.gui = gui;
        frame = this;
        initComponents();
        MojeMenu.menuTab(this);
        gui.centruj(this);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButtonStorno = new javax.swing.JButton();
        jButtonKrok = new javax.swing.JButton();
        jButtonBeh = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jButtonCSV = new javax.swing.JButton();
        jLabelCas = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        jTable3 = new javax.swing.JTable();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTable2 = new javax.swing.JTable();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableShluky = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jScrollPane5 = new javax.swing.JScrollPane();
        jTable4 = new javax.swing.JTable();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jButtonStorno.setText("Cancel");
        jButtonStorno.setToolTipText("Nvrat na nastaven algoritmu");
        jButtonStorno.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStornoActionPerformed(evt);
            }
        });

        jButtonKrok.setText("Step");
        jButtonKrok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonKrokActionPerformed(evt);
            }
        });

        jButtonBeh.setText("Run");
        jButtonBeh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonBehActionPerformed(evt);
            }
        });

        jLabel2.setText(null
        );

        jLabel3.setText(null);

        jButtonCSV.setText("Clusters export");
        jButtonCSV.setToolTipText("Ulo do csv dokumenty s shluky a nejastjmi klovmi slovy");
        jButtonCSV.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCSVActionPerformed(evt);
            }
        });

        jLabelCas.setText(null);

        jLabel4.setText(null);

        jLabel5.setText(null);

        jTable3.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3"
            }
        ));
        jTable3.getTableHeader().setReorderingAllowed(false);
        jScrollPane4.setViewportView(jTable3);

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable2.getTableHeader().setReorderingAllowed(false);
        jTable2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTable2MouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTable2MousePressed(evt);
            }
        });
        jScrollPane2.setViewportView(jTable2);

        jTableShluky.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Id", "Documents", "Keywords", "Title 4"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTableShluky.getTableHeader().setReorderingAllowed(false);
        jTableShluky.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTableShlukyMouseReleased(evt);
            }
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTableShlukyMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTableShlukyMousePressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTableShluky);

        jLabel1.setText("Clusters (display details after click):");

        jLabel6.setText("Keywords and centroids of a chosen cluster:");

        jLabel7.setText("Documents in a chosen cluster:");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 984, Short.MAX_VALUE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel7)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 501, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel6)
                            .addComponent(jScrollPane4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 175, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jLabel7))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 263, Short.MAX_VALUE)
                    .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 263, Short.MAX_VALUE))
                .addContainerGap())
        );

        jTabbedPane1.addTab("Clusters Overview", jPanel1);

        jTable4.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jTable4.getTableHeader().setReorderingAllowed(false);
        jScrollPane5.setViewportView(jTable4);
        jTable4.getColumnModel().getColumn(0).setMinWidth(30);
        jTable4.getColumnModel().getColumn(0).setPreferredWidth(60);
        jTable4.getColumnModel().getColumn(0).setMaxWidth(150);

        jTabbedPane1.addTab("Category distribution in clusters", jScrollPane5);

        jLabel8.setText("Criterion function: 1st part:");

        jLabel9.setText("2nd part");

        jLabel10.setText("Algorithm run time:");

        jLabel11.setText("F Score:");

        jLabel12.setText("Ratio of correctly clustered documents:");

        jLabel13.setText("Count of negative weights found (overall for all iterations):");

        jLabel14.setText(null);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jTabbedPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 1009, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(40, 40, 40)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel8)
                            .addComponent(jLabel10)
                            .addComponent(jLabel12)
                            .addComponent(jLabel13))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 177, Short.MAX_VALUE)
                                    .addComponent(jLabelCas, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel5))
                                .addGap(14, 14, 14)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel11)
                                        .addGap(7, 7, 7))
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(jLabel9)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)))
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 164, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addComponent(jLabel14))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jButtonCSV, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(jButtonStorno, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jButtonBeh, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 70, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jButtonKrok, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jTabbedPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 546, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(jLabel8)
                            .addComponent(jLabel2)
                            .addComponent(jLabel9))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelCas)
                            .addComponent(jLabel10))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel5)
                            .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel11)
                            .addComponent(jLabel4))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel13)
                            .addComponent(jLabel14)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButtonCSV)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButtonBeh)
                            .addComponent(jButtonKrok))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonStorno)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonStornoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStornoActionPerformed
        gui.dokonciPredzpracovani();
    }//GEN-LAST:event_jButtonStornoActionPerformed

    private void jTableShlukyMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableShlukyMouseClicked
    }//GEN-LAST:event_jTableShlukyMouseClicked

    private void jTable2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable2MouseClicked
    }//GEN-LAST:event_jTable2MouseClicked

    /**
     * Selection of a cluster and tables actualization
     * @param evt mouse event
     */
    private void jTableShlukyMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableShlukyMousePressed

        try {
            vybranyShluk = gui.getAlg().getShluky().get(jTableShluky.getSelectedRow());
        } catch (Exception e) {
        }

        if (vybranyShluk != null) {
            aktualizujTabulkaDokumentu();
            aktualizujTabulka4();

        }
    }//GEN-LAST:event_jTableShlukyMousePressed

    private void jTable2MousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTable2MousePressed

        try {
            vybranyDokumentShluku = vybranyShluk.getDokumentyShluku().get(jTable2.getSelectedRow());
            // aktualizujTabulkaVah();
        } catch (Exception e) {
        }

    }//GEN-LAST:event_jTable2MousePressed

    private void jButtonKrokActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonKrokActionPerformed
        gui.krok();
    }//GEN-LAST:event_jButtonKrokActionPerformed

    private void jButtonBehActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonBehActionPerformed
        gui.beh();
    }//GEN-LAST:event_jButtonBehActionPerformed

    /**
     * Generating of CSV file. Chooses the file and sends it to the controller layer.
     * @param evt event
     */
    private void jButtonCSVActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCSVActionPerformed
        File soubor;
        try {
            JFileChooser fc = new JFileChooser();
            fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
            fc.setDialogTitle("Choose CSV file to store clusters");
            fc.setDialogType(JFileChooser.SAVE_DIALOG);
            fc.setApproveButtonText("Save");

            soubor = new java.io.File(".");

            fc.setCurrentDirectory(soubor);
            fc.setFileFilter(new CSVFiltr());
            fc.showSaveDialog(this);
            soubor =
                    fc.getSelectedFile();
            if (soubor == null) {
                return;
            }
            gui.csv(soubor);
        } catch (Exception ee) {
            Main.vyridVyjimku(new Exception("Unable to choose file"));
            return;

        }
    }//GEN-LAST:event_jButtonCSVActionPerformed
    /**
     * Selection of a cluster and tables actualization
     * @param evt mouse event
     */
    private void jTableShlukyMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableShlukyMouseReleased
        try {
            vybranyDokumentShluku = vybranyShluk.getDokumentyShluku().get(jTable2.getSelectedRow());
            // aktualizujTabulkaVah();
        } catch (Exception e) {
        }
    }//GEN-LAST:event_jTableShlukyMouseReleased
    /**
     * Filling of a table of term weights.
     */
    public Object[][] naplnTabulkaVah() throws Exception {

        Object dataTabulka[][] = new Object[vybranyDokumentShluku.getDkw().length][2];
        int i = 0;
        for (; i <
                vybranyDokumentShluku.getDkw().length;) {


            dataTabulka[i][1] = vybranyDokumentShluku.getDkw()[i];
            // dataTabulka[i][0] = ((Slovo) vybranyDokumentShluku.getDokument().getSlova().values().toArray()[i]).getVaha();
            dataTabulka[i][0] = ((Slovo) vybranyDokumentShluku.getDokument().getSlova().values().toArray()[i]).getJmeno();
            i++;

        }


        return dataTabulka;

    }

    /**
     * Filling of the table of all key words.
     * @return key word table
     * @throws Exception
     */
    public Object[][] naplnTabulkaKlicovychSlov() throws Exception {
        int i = 0, delka = 0;

        try {
            delka = vybranyShluk.getKlicovaSlova().size();
            //   System.out.println(delka);

            Object dataTabulka[][] = new Object[delka][3];
            int id;
            i =
                    0;
            //  for (SlovaSuma s : gui.getData().getSlovaDokumenty().values()) {
            for (Slovo s : vybranyShluk.getKlicovaSlova()) {
                id = s.getId();
                dataTabulka[i][0] = s.getJmeno();
                dataTabulka[i][1] = vybranyShluk.getCentrum()[id];
                dataTabulka[i][2] = vybranyShluk.getVahy()[id];
                i++;
            }


            return dataTabulka;
        } catch (Exception e) {

            return null;
        }

    }


    /**
     * Actualization of the table of all key words.
     */
    public void aktualizujTabulka4() {
        try {

            jTable3.setModel(new javax.swing.table.DefaultTableModel(
                    naplnTabulkaKlicovychSlov(),
                    new String[]{
                        "Keyword", "Centre", "Weight"
                    }) {

                @Override
                public Class getColumnClass(
                        int columnIndex) {
                    return String.class;
                }
            });
        } catch (Exception e) {
        }
        jTable3.setEnabled(false);
    }

    /**
     * Filling of the table of all clusters
     * @return table of clusters
     */
    public Object[][] naplnTabulkaShluku() throws Exception {

        Object dataTabulka[][] = new Object[gui.getAlg().getPocetShluku()][5];
        int i = 0;
        for (Shluk s : gui.getAlg().getShluky()) {


            dataTabulka[i][0] = i;
            dataTabulka[i][1] = s.getDokumentyShluku().size();
            dataTabulka[i][2] = s.getDelta();
            dataTabulka[i][3] = s.getVzdalenostPrazdnehoDokumentu();
            dataTabulka[i][4] = s.getStred();

            i++;

        }


        return dataTabulka;

    }

    /**
     * Actualization of the table of all clusters at model layer.
     */
    public void aktualizujTabulkaShluku() {



        try {
            jTableShluky.setModel(new javax.swing.table.DefaultTableModel(
                    naplnTabulkaShluku(),
                    new String[]{
                        "Cluster ID", "Dokuments", "Delta", "Distance of empty document", "Initialization document"
                    }) {

                Class[] types = new Class[]{
                    java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
                };

                @Override
                public Class getColumnClass(int columnIndex) {
                    return types[columnIndex];
                }
            });
        } catch (Exception e) {
        }
       jTableShluky.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    }

    /**
     * For a selected cluster, it displays documents of that cluster in a table.
     * @return table of documents
     */
    public Object[][] naplnTabulkaDokumentuShluku() throws Exception {
        try {
            Object dataTabulka[][] = new Object[vybranyShluk.getDokumentyShluku().size()][3];
            int i = 0;
            for (DokumentShluku d : vybranyShluk.getDokumentyShluku()) {


                dataTabulka[i][0] = d.getDokument().getJmeno();
                dataTabulka[i][1] = d.getVzdalenostDokumentu();
                dataTabulka[i][2] = d.getDokument().getKategorie();

                i++;
            }
            return dataTabulka;
        } catch (Exception e) {
        }
        return null;
    }

    /**
     * Actualization of the table of documents at model layer.
     */
    public void aktualizujTabulkaDokumentu() {
        try {
            jTable2.setModel(new javax.swing.table.DefaultTableModel(
                    naplnTabulkaDokumentuShluku(),
                    new String[]{
                        "Document", "Distance from centre", "Category"
                    }) {

                @Override
                public Class getColumnClass(int columnIndex) {
                    return java.lang.String.class;
                }
            });
        } catch (Exception e) {
        }
        jTable2.setEnabled(false);
    }

    /**
     * Generates new data for a contingention table. 
     * @return contingention table
     */
    private Object[][] naplnTabulkaValidace() {

        try {
            int[][] data = gui.getAlg().getValidace().getTabulka();
            int[] data2 = gui.getAlg().getValidace().getSuma();
            Object dataTabulka[][] = new Object[data.length + 3][data[0].length + 1];
            for (int i = 0; i < data.length; i++) {
                dataTabulka[i][0] = i;
                for (int j = 0; j < data[i].length; j++) {

                    dataTabulka[i][j + 1] = data[i][j];
                }

            }
            for (int j = 0; j < data2.length; j++) {

                dataTabulka[data.length][j + 1] = data2[j];
            }
            dataTabulka[data.length][0] = "Sum:";
            data2 = gui.getAlg().getValidace().getShlukyID();
            for (int j = 0; j < data2.length - 1; j++) {

                dataTabulka[data.length + 1][j + 1] = data2[j];
            }

            double[] data3 = gui.getAlg().getValidace().getUspesnost();
            for (int j = 0; j < data3.length - 1; j++) {

                dataTabulka[dataTabulka.length - 1][j + 1] = IO.formatDouble().format(data3[j]) + "";
            }
            dataTabulka[data.length + 1][0] = "probable cluster:";
            dataTabulka[dataTabulka.length - 1][0] = "dílčí F-score:";
            return dataTabulka;
        } catch (Exception e) {
        }
        return null;
    }

    /**
     * Actualization of the contingention table at model layer.
     */
    public void aktualizujTabulkaValidace() {
        try {

            DefaultTableModel model = new javax.swing.table.DefaultTableModel(
                    naplnTabulkaValidace(),
                    gui.getAlg().getValidace().getPopisky()) {

                @Override
                public boolean isCellEditable(int rowIndex, int columnIndex) {
                    return false;
                }

                @Override
                public Class getColumnClass(int columnIndex) {
                    return java.lang.String.class;
                }
            };

            jTable4.setModel(model);
            jTable4.getColumnModel().getColumn(0).setPreferredWidth(140);
            for (int i = 1; i < jTable4.getColumnModel().getColumnCount(); i++) {

                jTable4.getColumnModel().getColumn(i).setPreferredWidth(100);

            }

            jTable4.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
            jTable4.setEnabled(false);
        } catch (Exception e) {
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonBeh;
    private javax.swing.JButton jButtonCSV;
    private javax.swing.JButton jButtonKrok;
    private javax.swing.JButton jButtonStorno;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelCas;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTable jTable3;
    private javax.swing.JTable jTable4;
    private javax.swing.JTable jTableShluky;
    // End of variables declaration//GEN-END:variables

    /**
     * Actualization of all fields placed on the algorithm window. 
     */
    public void nastav() {

        String titulek;
        if (gui.getAlg().getIterace() == 0) {
            titulek = "SKWIC after initialization";
        } else if (gui.getAlg().isHotovo()) {
            titulek = "SKWIC finished(after " + gui.getAlg().getIterace() + ". iterations)";
        } else {
            titulek = "SKWIC iteration " + gui.getAlg().getIterace();
        }
        this.setTitle(titulek);
        jButtonKrok.setEnabled(!gui.getAlg().isHotovo());
        jButtonBeh.setEnabled(!gui.getAlg().isHotovo());
        aktualizujTabulkaShluku();

        if (vybranyShluk == null) {
            vybranyShluk = gui.getAlg().getShluky().get(0);
        } else if (!gui.getAlg().getShluky().contains(vybranyShluk)) {
            vybranyShluk = gui.getAlg().getShluky().get(0);
        }
        jTableShluky.changeSelection(gui.getAlg().getIdShluku(vybranyShluk), 0, false, false);
        //aktualizujTabulkaVah();
        aktualizujTabulkaDokumentu();
        aktualizujTabulkaValidace();
        aktualizujTabulka4();
        setEnabled(true);
        toFront();
        //      repaint();
        jLabel3.setText("" + gui.getAlg().getPrvni());
        jLabel2.setText("" + gui.getAlg().getDruha());
        jLabelCas.setText((double) gui.getAlg().getDobaBehu() / 1000 + " s");
        jLabel4.setText("" + gui.getAlg().getValidace().getfSkore());
        jLabel5.setText("" + gui.getAlg().getValidace().getPrumer());
        jLabel14.setText("" + gui.getAlg().getZaporne());
    }
}
