/* 
 * Method for clustering text data, SKWIC algorithm implementation
 * View class generating the window displaying pre-processing results
 * Created by: Roman Milos, Vladimir Bartik, May 2011
 */

package dip.pohled;

import dip.kontroler.Gui;
import dip.Main;
import dip.model.Dokument;
import dip.model.Data;
import dip.model.IO;
import dip.model.Predzpracovani;
import dip.model.SlovoSuma;
import dip.model.Slovo;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.ListSelectionModel;
import javax.swing.table.DefaultTableModel;

/**
 * View class generating the window displaying pre-processing results
 * @author Roman
 */
public class VysledkyPredzpracovaniOkno extends javax.swing.JFrame {

    public Data data;
    public Gui gui;
    private Dokument vybranyDokument;

    public Dokument getVybranyDokument() {
        return vybranyDokument;
    }

    public void setVybranyDokument(Dokument vybranyDokument) {
        this.vybranyDokument = vybranyDokument;
    }

    /** Creates new form VysledkyPredzpracovaniOkno */
    public VysledkyPredzpracovaniOkno(Gui gui) {
        this.gui = gui;
        data = Data.getInstance();
        initComponents();
        MojeMenu.menuTab(this);
        gui.centruj(this);


    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTabulka = new javax.swing.JTable();
        jLabel1 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTabulkaTermu = new javax.swing.JTable();
        jLabel2 = new javax.swing.JLabel();
        jSeparator2 = new javax.swing.JSeparator();
        jTextField1 = new javax.swing.JTextField();
        jLabelPocetTermu = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jButtonExportTXT = new javax.swing.JButton();
        jLabel9 = new javax.swing.JLabel();
        jLabelCas = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("SKWIC - algorithm settings");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));

        jButton1.setText("Cancel");
        jButton1.setToolTipText("Nvrat na pedchzejc okno");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jButton2.setText("Run algorithm");
        jButton2.setToolTipText("Spust9 provdn algoritmu");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jTabulka.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Name", "Title", "Category", "Term count"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTabulka.getTableHeader().setReorderingAllowed(false);

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, jTabulka, org.jdesktop.beansbinding.ObjectProperty.create(), jTabulka, org.jdesktop.beansbinding.BeanProperty.create("selectedElement"), "vybrane");
        bindingGroup.addBinding(binding);

        jTabulka.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                jTabulkaMouseReleased(evt);
            }
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTabulkaMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                jTabulkaMousePressed(evt);
            }
        });
        jScrollPane1.setViewportView(jTabulka);

        jLabel1.setText("Documents in dataset (Display terms after click): ");

        jTabulkaTermu.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Title 1", "Title 2", "Title 3"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Integer.class, java.lang.Double.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTabulkaTermu.getTableHeader().setReorderingAllowed(false);
        jScrollPane2.setViewportView(jTabulkaTermu);
        jTabulkaTermu.getColumnModel().getColumn(0).setPreferredWidth(130);
        jTabulkaTermu.getColumnModel().getColumn(0).setHeaderValue("Title 1");
        jTabulkaTermu.getColumnModel().getColumn(1).setHeaderValue("Title 2");
        jTabulkaTermu.getColumnModel().getColumn(2).setHeaderValue("Title 3");

        jLabel2.setLabelFor(jTabulkaTermu);
        jLabel2.setText("Terms of selected document:");

        jTextField1.setToolTipText("Poet td do kterch se maj dokumenty rodelit");
        jTextField1.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField1FocusLost(evt);
            }
        });
        jTextField1.addInputMethodListener(new java.awt.event.InputMethodListener() {
            public void caretPositionChanged(java.awt.event.InputMethodEvent evt) {
            }
            public void inputMethodTextChanged(java.awt.event.InputMethodEvent evt) {
                jTextField1InputMethodTextChanged(evt);
            }
        });

        jLabelPocetTermu.setText(""+data.getSlovaDokumenty().size());

        jLabel4.setText("Term count after pre-processing:");

        jLabel5.setText("Documents count:");

        jLabel3.setText(null);

        jLabel6.setText("Required count of classes:");

        jLabel7.setText("Classes count(according to categories):");

        jLabel8.setText(""+data.getPocetTrid());

        jButtonExportTXT.setText("Export documents");
        jButtonExportTXT.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonExportTXTActionPerformed(evt);
            }
        });

        jLabel9.setText("Pre-processing time:");

        jLabelCas.setText(null);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane3.setViewportView(jTable1);

        jLabel10.setText("Terms which occur in a set of documents:");

        jLabel11.setText("Weighting constant:");

        jTextField2.setToolTipText("Pokud aplikace generuje przdn shluky je nutn zvit konstantu pro vhovn");
        jTextField2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jTextField2ActionPerformed(evt);
            }
        });
        jTextField2.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                jTextField2FocusLost(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 430, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 64, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 387, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel10)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 426, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(68, 68, 68)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton2)
                        .addGap(90, 90, 90)
                        .addComponent(jButton1))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel11)
                            .addComponent(jLabel5)
                            .addComponent(jLabel4)
                            .addComponent(jLabel9)
                            .addComponent(jLabel7)
                            .addComponent(jLabel6)
                            .addComponent(jButtonExportTXT))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabelCas)
                            .addComponent(jLabelPocetTermu, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel3)
                            .addComponent(jLabel8)
                            .addComponent(jTextField1, javax.swing.GroupLayout.DEFAULT_SIZE, 69, Short.MAX_VALUE)
                            .addComponent(jTextField2))))
                .addContainerGap())
            .addComponent(jSeparator2, javax.swing.GroupLayout.DEFAULT_SIZE, 901, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, 0, 0, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 208, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(8, 8, 8)
                .addComponent(jSeparator2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(22, 22, 22)
                .addComponent(jLabel10)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabelCas)
                            .addComponent(jLabel9))
                        .addGap(9, 9, 9)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel4)
                            .addComponent(jLabelPocetTermu))
                        .addGap(12, 12, 12)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel3)
                            .addComponent(jLabel5))
                        .addGap(12, 12, 12)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel8)
                            .addComponent(jLabel7))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel6)
                            .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel11, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jTextField2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonExportTXT)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jButton2)
                            .addComponent(jButton1)))
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 292, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(33, 33, 33))
        );

        bindingGroup.bind();

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * A "cancel" button.
     * @param evt
     */
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed

        gui.spustitInicializaci();

    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * Executes the algorithm. State of all components is verified, sets the model layer 
     * and lets the controller begin the algorithm.
     * @param evt event
     */
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        try {
            double konstanta = new Double(jTextField2.getText());
            if (konstanta == 0) {
                throw new Exception();
            }
            data.setKonstanta(konstanta);

        } catch (Exception e) {
            Main.vyridVyjimku(new Exception("Constant must be a double number not equal to zero."));
            return;
        }
        int cislo = 0;
        try {
            cislo = new Integer(jTextField1.getText());

        } catch (Exception e) {
            Main.vyridVyjimku(new Exception("Unable to convert class count to a number"));
            return;
        }
        if (cislo < 1 || cislo >= data.getDokumenty().size()) {
            Main.vyridVyjimku(new Exception("Class number must be in a range 1-" + (data.getDokumenty().size())));
            return;
        } else {
            if (data.getPocetTrid() != cislo) {
                data.setPocetTrid(cislo);
            }
            gui.inicializace();
        }
    }//GEN-LAST:event_jButton2ActionPerformed
    /**
     * Actualization of selected document and displaying a new table. 
     * @param evt event
     */
    private void jTabulkaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTabulkaMouseClicked
        // JOptionPane.showMessageDialog(null, jTabulka.getSelectedRow(), "Chyba", JOptionPane.ERROR_MESSAGE);
        vybranyDokument = data.getDokumenty().get(jTabulka.getSelectedRow());

        aktualizujTabulkaTermu();
        // System.out.println(vybranyDokument.getSlova().size());

    }//GEN-LAST:event_jTabulkaMouseClicked
    /**
     * Actualization of selected document and displaying a new table. 
     * @param evt event
     */
    private void jTabulkaMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTabulkaMousePressed
        vybranyDokument = data.getDokumenty().get(jTabulka.getSelectedRow());

        aktualizujTabulkaTermu();
    }//GEN-LAST:event_jTabulkaMousePressed

    /**
     * Actualization of selected document and displaying a new table. 
     * @param evt event
     */
    private void jTabulkaMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTabulkaMouseReleased
        vybranyDokument = data.getDokumenty().get(jTabulka.getSelectedRow());

        aktualizujTabulkaTermu();
    }//GEN-LAST:event_jTabulkaMouseReleased

    private void jTextField1InputMethodTextChanged(java.awt.event.InputMethodEvent evt) {//GEN-FIRST:event_jTextField1InputMethodTextChanged
    }//GEN-LAST:event_jTextField1InputMethodTextChanged

    private void jTextField1FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField1FocusLost
    }//GEN-LAST:event_jTextField1FocusLost

    /**
     * Exporting the document. Gets the file name and fills it with the data. 
     * @param evt event
     */
    private void jButtonExportTXTActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonExportTXTActionPerformed
        File soubor;
        try {
            JFileChooser fc = new JFileChooser();
            fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
            fc.setDialogTitle("Choose file to export documents");
            fc.setDialogType(JFileChooser.SAVE_DIALOG);
            fc.setApproveButtonText("Save");

            soubor = new java.io.File(".");
            fc.setCurrentDirectory(soubor);

            fc.showSaveDialog(this);
            soubor =
                    fc.getSelectedFile();
            if (soubor == null) {
                return;
            }
            IO.ulozDokumenty(soubor);
        } catch (Exception ee) {
            Main.vyridVyjimku(new Exception("Unable to read file"));
            return;

        }

    }//GEN-LAST:event_jButtonExportTXTActionPerformed

    private void jTextField2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jTextField2ActionPerformed
    }//GEN-LAST:event_jTextField2ActionPerformed

    /**
     * Sets a new constant. 
     * @param evt event
     */
    private void jTextField2FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jTextField2FocusLost
        try {
            double konstanta = new Double(jTextField2.getText());
            data.setKonstanta(konstanta);

        } catch (Exception e) {
            Main.vyridVyjimku(new Exception("Constant must be a double number"));
        }
    }//GEN-LAST:event_jTextField2FocusLost
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButtonExportTXT;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JLabel jLabelCas;
    private javax.swing.JLabel jLabelPocetTermu;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTabulka;
    private javax.swing.JTable jTabulkaTermu;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables

    /**
     * Actualization of window components by values from model layer. 
     */
    public void nastav() {

        this.setVisible(true);
        jTextField1.setText("" + data.getPocetTrid());
        jLabelPocetTermu.setText("" + data.getSlovaDokumenty().size());
        jLabel3.setText("" + data.getDokumenty().size());
        jLabel8.setText("" + data.getKategorie().size());
        //   jLabel5.setText(""+data.get)
        aktualizujTabulkaDokumentu();
        // algOkno.setVybranyDokument(data.getDokumenty().get(0));
        aktualizujTabulkaTermu();
        aktualizujTabulkaVsechTermu();
        jLabelCas.setText((double) (Predzpracovani.getInstance().getCas()) / 1000 + " s");

        this.repaint();
    }

    /**
     * Gets necessary data for the list of all terms. 
     * @return list of all terms
     */
    public Object[][] naplnTabulkaVsechTermu() {
        try {
            Object dataTabulka[][] = new Object[data.getSlovaDokumenty().size()][4];
            int i = 0;

            for (SlovoSuma s : data.getSlovaDokumenty().values()) {

                dataTabulka[i][0] = s.getJmeno();
                dataTabulka[i][1] = s.getPocetDokumentu();
                dataTabulka[i][2] = s.getMaximalniVyskyty();
                dataTabulka[i][3] = s.getPocet();
                i++;
            }

            return dataTabulka;
        } catch (Exception e) {
        }
        return null;
    }

    /**
     * Gets necessary data for the list of all documents. 
     * @return list of all documents
     */
    public Object[][] naplnTabulkaDokumentu() {
        Object dataTabulka[][] = new Object[data.getDokumenty().size()][4];
        int i = 0;
        for (Dokument d : data.getDokumenty()) {


            dataTabulka[i][0] = d.getJmeno();
            dataTabulka[i][1] = d.getTitle();
            dataTabulka[i][2] = d.getKategorie();
            dataTabulka[i][3] = d.getSlova().size();


            i++;
        }
        return dataTabulka;

    }

    /**
     * Gets necessary data for the list of actual terms. 
     * @return list of actual terms
     */
    public Object[][] naplnTabulkaTermu() {
        try {
            Object dataTabulka[][] = new Object[vybranyDokument.getSlova().size()][3];
            int i = 0;

            for (Slovo s : vybranyDokument.getSlova().values()) {

                dataTabulka[i][0] = s.getJmeno();
                dataTabulka[i][1] = s.getPocet();
                dataTabulka[i][2] = IO.formatDouble().format(s.getVaha());
                i++;
            }

            return dataTabulka;
        } catch (Exception e) {
        }
        return null;
    }

    /**
     * Actualization of table with terms of a selected document.
     */
    public void aktualizujTabulkaTermu() {
        String vaha = "Weight (" + data.getVahovani().toString() + ")";

        DefaultTableModel model = new DefaultTableModel(
                naplnTabulkaTermu(),
                new String[]{
                    "Term", "Count", vaha
                }) {

            Class[] types = new Class[]{
                java.lang.String.class, java.lang.Integer.class, java.lang.String.class
            };

            @Override
            public Class getColumnClass(int columnIndex) {
                return types[columnIndex];
            }

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return false;
            }
        };
        jTabulkaTermu.setModel(model);

        jTabulkaTermu.setEnabled(false);


    }

    /**
     * Actualization of table with all documents.
     */
    public void aktualizujTabulkaDokumentu() {

        jTabulka.setModel(new javax.swing.table.DefaultTableModel(
                naplnTabulkaDokumentu(),
                new String[]{
                    "Name", "Title", "Category", "Term count"
                }) {

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return false;
            }

            @Override
            public Class getColumnClass(int columnIndex) {
                return java.lang.String.class;
            }
        });

        jTabulka.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);



    }

    /**
     * Actualization of table with all documents.
     */
    public void aktualizujTabulkaVsechTermu() {

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
                naplnTabulkaVsechTermu(),
                new String[]{
                    "Term", "Documents count", "Maximum occurence", "Overall occurence"
                }) {

            @Override
            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return false;
            }

            @Override
            public Class getColumnClass(int columnIndex) {
                return java.lang.String.class;
            }
        });

        jTable1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        jTable1.setEnabled(false);
        jTextField2.setText(data.getKonstanta() + "");
    }
}
